
function buildOptions(name, addon)
  return {
    name = name,
    handler = addon,
    type = "group",
    set = "SetOption",
    get = "GetOption",
    args = {
      description = {
        order = 1,
        type = "description",
        name = "GuildArtisan TODO."
      },
      expansion_settings = {
        order = 2,
        type = "group",
        name = "Expansion Settings",
        inline = true,
        args = {
          help = {
            order = 1,
            type = "description",
            name = "Expansion-specific settings.",
          },
          group_1 = {
            order = 2,
            type = "group",
            name = "",
            inline = true,
            args = {
              expansion_select = {
                order = 2,
                type = "select",
                name = "Expansion",
                desc = "The expansion to use for skills.",
                arg = "expansion",
                values = {
                  ["shadowlands"] = "Shadowlands",
                }
              },
            }
          },
          group_2 = {
            order = 3,
            type = "group",
            name = "",
            inline = true,
            args = {
              special_recipes_only = {
                order = 2,
                type = "toggle",
                name = "Special Recipes Only",
                desc = "Only include expansion-specific special recipes?",
                arg = "specialRecipesOnly",
              },
            }
          },
        }
      },
      help_group = {
        order = 3,
        type = "group",
        name = "Chat Commands",
        inline = true,
        args = {
          group_1 = {
            order = 1,
            type = "group",
            name = "",
            inline = true,
            args = {
              help_text_1 = {
                order = 1,
                type = "description",
                name = "/ga clear - Clear cache."
              },
              help_text_2 = {
                order = 2,
                type = "description",
                name = "/ga config - Open addon config panel."
              },
              help_text_3 = {
                order = 3,
                type = "description",
                name = "/ga lock - Lock the window position."
              },
              help_text_4 = {
                order = 4,
                type = "description",
                name = "/ga unlock - Unlock the window position."
              },
              help_text_5 = {
                order = 5,
                type = "description",
                name = "/ga toggle - Toggle the window visibility."
              },
            },
          },
        },
      },
      extras_group = {
        order = 4,
        type = "group",
        name = "Extras",
        inline = true,
        args = {
          group_1 = {
            order = 1,
            type = "group",
            name = "",
            inline = true,
            args = {
              debug_mode = {
                order = 2,
                type = "toggle",
                name = "Debug",
                desc = "Show debug output?",
                arg = "debug",
              },
            },
          },
        },
      },
    }
  }
end

