--
-- Throttle
--
-- Copyright (c) 2021 Dana Basken
--

Throttle = {}
Throttle.__index = Throttle

function Throttle:Create(windowSeconds)
  local instance = {}
  setmetatable(instance, Throttle)
  instance:Construct(windowSeconds)
  return instance
end

function Throttle:Construct(windowSeconds)
  self.windowSeconds = windowSeconds
end

function Throttle:SetWindowSeconds(seconds)
  self.windowSeconds = seconds
end

function Throttle:Do(callback)
  self:Cancel()
  self.throttleTimer = C_Timer.NewTicker(self.windowSeconds, function()
    self:Cancel()
    callback()
  end, 0)
end

function Throttle:Cancel()
  if self.throttleTimer then
    self.throttleTimer:Cancel()
    self.throttleTimer = nil
  end
end
